using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Runtime.CompilerServices;
using Windows.ApplicationModel.Core;
using Windows.UI.Core;
using Windows.UI.Popups;
using DAQCdashboard.Annotations;

namespace DAQCdashboard.ViewModels
{
    public class AnalogIo : INotifyPropertyChanged
    {
        private float _value;

        public float MinValue { get; set; } = float.MinValue;

        public float MaxValue { get; set; } = float.MaxValue;

        public byte Channel { get; set; }

        public float Value
        {
            get { return _value; }
            set
            {
                if (value.Equals(_value)) return;
                //todo: validate user input
                
                _value = value;
                OnPropertyChanged();
            }
        }

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}