using System.ComponentModel;
using System.Runtime.CompilerServices;
using DAQCdashboard.Annotations;

namespace DAQCdashboard.ViewModels
{
    public class DigitalIo : INotifyPropertyChanged
    {
        private bool _value;
        public byte Channel { get; set; }

        public bool Value
        {
            get { return _value; }
            set
            {
                if (value == _value) return;
                _value = value;
                OnPropertyChanged();
            }
        }

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}